-- Operations with Unlimited number allocated staticaly
-- You may use and modify this file free
-- without deleting this comment group
-- Copyright (c) 1999 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
package Unlimited.Number is 

   subtype Part is Int;
   type Unlimited_Static is array(Integer range <>) of Part;
   pragma Pack(Unlimited_Static);

   function Integer2Unlimited(I : Int) return Unlimited_Static;

   function "+"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "-"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "*"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "/"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "rem"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "*"(Left : in Unlimited_Static;Right : Int) return Unlimited_Static;
   function "/"(Left : in Unlimited_Static;Right : Int) return Unlimited_Static;
   function "rem"(Left : in Unlimited_Static;Right : Int) return Unlimited_Static;
   
   function "-"(UI : in Unlimited_Static) return Unlimited_Static;
   function "abs"(UI : in Unlimited_Static) return Unlimited_Static;

   function "and"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "or"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   function "xor"(Left,Right : in Unlimited_Static) return Unlimited_Static;
   
   function "<"(Left,Right : Unlimited_Static) return Boolean;
   function ">"(Left,Right : Unlimited_Static) return Boolean;
   function "<="(Left,Right : Unlimited_Static) return Boolean;
   function ">="(Left,Right : Unlimited_Static) return Boolean;
   function "="(Left,Right : Unlimited_Static) return Boolean;
   
   function Shift(UI : Unlimited_Static;Amount : Integer) return Unlimited_Static;

   Hexdigs : Conversion_Chars(0 .. 15) := "0123456789ABCDEF";
   Division_By_Zero : exception;
   
   procedure Divide(Numer : in Unlimited_Static;Denom : in Int;
         Result,Remainder : out Unlimited_Static);
         
   procedure Divide(Numerator,Denominator : in Unlimited_Static;
         Result,Remainder : out Unlimited_Static);   
   subtype Base_Of_Presentation is Int range 2..16;
   function To_String(Num : in Unlimited_Static; 
         Trans : in Conversion_Chars;Power2Enabled : Boolean:=True) return String;
   function To_String(Num : in Unlimited_Static; 
         Base : Base_Of_Presentation :=10;Power2Enabled : Boolean:=True) return String;   
         
   Nil : constant Unlimited_Static := (0=>0);

  -- pragma Inline(Integer2Unlimited,"+","/","rem","abs");
   
end Unlimited.Number;