-- Root for Unlimited_Number
-- You may use and modify this file free
-- without deleting this comment group
-- Copyright (c) 1999 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
with Ada.Unchecked_Conversion,System;
package body Unlimited is

   use System;

   Low_Idx : constant Boolean :=
      Low_Order_First/=Default_Bit_Order;
   High_Idx : constant Boolean := not Low_Idx;

   type DInt is array(Boolean) of Int;

   function To_DInt is new Ada.Unchecked_Conversion(LLI,DInt);
   function To_LLi is new Ada.Unchecked_Conversion(DInt,LLI);

   function High(L : Lli) return Int is
   begin
      return To_DInt(L)(High_Idx);
   end;

   function Low(L : Lli) return Int is
   begin
      return To_DInt(L)(Low_Idx);
   end;

   function To_Lli(Low : Int; High : Int) return LLI is
      Result : DInt;
   begin
      Result(Low_Idx) := Low;
      Result(High_Idx) := High;
      return To_LLI(Result);
   end;

   procedure Set_Low(Dest : in out LLI; Low : Int) is
   begin
      Dest := To_LLI(Low => Low, High => High(Dest));
   end;

   procedure Set_High(Dest : in out LLI; High : Int) is
   begin
      Dest := To_LLI(Low => Low(Dest), High => High);
   end;

   function To_LLI(From : UInt) return LLI is
   begin
      return LLI(From);
   end;

   function To_LLI(From : Int) return LLI is
   begin
      return LLI(From);
   end;

   function "*"(I1,I2 : Int) return LLI is
   begin
      return LLI(I1)*LLI(I2);
   end;

   function "*"(Ui : UInt;I : Int) return LLI is
   begin
      return LLI(Ui)*LLI(I);
   end;

   function "*"(I : Int;Ui : UInt) return LLI is
   begin
      return Ui*I;
   end;

end Unlimited;
